#include <map>
#include <list>
#include <iostream>

int main(int argc, char *argv[])
{
    std::map<std::string, int> conteosPorPalabra;

    // Bucle de lectura
    while (!std::cin.eof()) {
        std::string palabra;
        std::cin >> palabra;
        if (!std::cin.fail()) {
            // Podemos usar el operador[] directamente porque si la palabra no
            // estaba insertada se insertará con un valor asociado por defecto,
            // que al ser de tipo int será 0.
            ++conteosPorPalabra[palabra];
        }
    }

    // Construcción del map para devolver las palabras con determinado
    // numero de repeticiones. Para este map la clave es el número de 
    // repeticiones y el valor es una lista o vector de palabras.
    std::map<int, std::list<std::string> > palabrasPorConteo;
    for (std::map<std::string, int>::const_iterator i = 
             conteosPorPalabra.begin();
         i != conteosPorPalabra.end(); ++i) {
        // De nuevo podemos utilizar el operador[] directamente porque el
        // contructor por defecto de un std::list crea una lista vacía.
        palabrasPorConteo[i->second].push_back(i->first);
    }

    for (std::map<int, std::list<std::string> >::const_iterator i = 
             palabrasPorConteo.begin();
         i != palabrasPorConteo.end(); ++i) {
        std::cout << "Palabras con " << i->first 
                  << " repeticiones:" << std::endl;
        for (std::list<std::string>::const_iterator j = i->second.begin();
             j != i->second.end(); ++j) {
            std::cout << *j << ' ';
        }
        std::cout << std::endl;
    }
}
